module.exports = {
    friendlyName: "Find",

    description: "Find Information User.",

    inputs: {
        search: {
            type: "string",
        },
        qui: {
            type: "string",
        },
        codeClasse: {
            type: "string",
        },
        anneeScolaire: {
            type: "string",
        },
    },

    exits: {
        notFound: {
            statusCode: 404
        },
    },

    fn: async function (inputs, exits) {
        const { id, user } = this.req.token;
        //console.log("ID", id, user.login, user.typeUser, user.codeEcole)
        //console.log("INPUTS", inputs)
        // VERIFICATION DU CODE ECOLE
        if (user.codeEcole === '' || user.codeEcole === null || user.codeEcole === undefined) {
            return exits.notFound({ message: "Veuillez préciser le code Ecole pour cet utulisateur pour a accéder a cette page!" })
        }
        ecoleVerif = await Ecoles.find({ codeEcole: user.codeEcole }).then(_.first)
        if (!ecoleVerif) {
            return exits.notFound({ message: "Cet utilisateur n'est attribué a aucune classe!" })
        }
        // FIN VERIF CODE ECOLE

        // VERIF SI ANNEE SCOLAIRE EST PASSEE
        console.log("Annee Scolaire", inputs.anneeScolaire)
        if (inputs.anneeScolaire === '' || inputs.anneeScolaire === null || inputs.anneeScolaire === undefined) {
            return exits.notFound({ message: "Veuillez préciser une année scolaire pour a accéder a cette page!" })
        }
        ///aFIN

        if (inputs.codeClasse === '' || inputs.codeClasse === null || inputs.codeClasse === undefined) {
            inputs.codeClasse = undefined
        }

        //// FIN

        this.req.query.limit = this.req.query.limit || "10";
        this.req.query.skip = this.req.query.skip || "0";

        let userCodeEcole;
        if (user.typeUser === 'ADMINISTRATION'|| user.typeUser === 'SECRETARIAT') {
            userCodeEcole = user.codeEcole
        } else if (user.typeUser === 'ADMIN') {
            userCodeEcole = undefined
        } else {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })

        }
        //console.log("userCodeEcole", userCodeEcole)

        let fixedAttr = ["codeEcole", "codeClasse", "anneeScolaire", "qui",];


        let cond = {
            codeEcole: userCodeEcole,
            codeClasse: inputs.codeClasse,
            anneeScolaire: inputs.anneeScolaire ? inputs.anneeScolaire : undefined,
            qui: inputs.qui || undefined,
            //dateQuittance: {'>=':inputs.startDate,'<=':inputs.endDate},

            or: [
                //{ matricule: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
                { titre: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
                { description: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
            ],
        };
        //console.log("cond", cond)

        let options = {
            ...this.req.query,
            fixCond: _.pick(cond, fixedAttr),
            sort: "id DESC",
        };


        let informations = await sails.helpers
            .paginator(InformationsUser, cond, options)
            .then(async (informations) => {
                informations.data = await Promise.all(
                    informations.data.map(async (information) => {
                        if (information.codeClasse) {
                            information.classe = await Classe.find({ codeClasse: information.codeClasse }).then(_.first);
                        }

                        /*if (quittance.matricule) {
                            quittance.eleve = await Eleves.find({ matricule: quittance.matricule, }).then(_.first);

                            let filiation = await Filiation.find({ matricule: quittance.matricule }).then(_.first);
                            if (filiation) {
                                quittance.parent = await Parents.find({ codeParent: filiation.codeParent }).then(_.first);
                                quittance.filiation = filiation
                            }
                        }

                        let detailsQuittances = await DetailsPaiement.find({ numeroQuittance: quittance.numeroQuittance })

                        quittance.detailsQuittances = detailsQuittances;
                        */

                        return information
                    })
                );
                return informations
            });



        // All done.
        return exits.success(informations);
    },
};
